package com.test.referencedata;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.junit.AfterClass;
import static org.junit.Assert.*;
import org.junit.BeforeClass;
import org.junit.Test;

import com.test.referencedata.impl.DataStoreImpl;

public class DataStoreImplTest {

	private static DataStore<Integer, SimpleDomain> dataStore;

	@BeforeClass
	public static void before() {
		try {
			dataStore = new DataStoreImpl<Integer, SimpleDomain>(
					"SimpleDomain", "sample-configs/SimpleDomain.xml",
					SimpleDomain.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@AfterClass
	public static void after() {
		dataStore = null;
	}

	@Test
	public void testRetreivalTime() {
		long start = System.currentTimeMillis();
		int size = dataStore.getAll().size();
		assertEquals(1000000, size);
		System.out.printf("getAll %d for SimpleDomains took %d ms%n", size,
				System.currentTimeMillis() - start);

	}

	@Test
	public void testSearch() {
		long start = System.currentTimeMillis();
		Map<Object, Object> searchParams = new HashMap<Object, Object>();
		searchParams.put("id", "1");
		Collection<SimpleDomain> results = dataStore.find(searchParams);
		assertEquals(1, results.size());
		System.out.printf("find got  %d results = %s in %d ms%n",
				results.size(), results, System.currentTimeMillis() - start);

	}

	@Test
	public void testSearchQuery() {
		long start = System.currentTimeMillis();

		Collection<SimpleDomain> results = dataStore.find("id:1*");
		assertEquals(1, results.size());
		System.out.printf("find got  %d results = %s in %d ms%n",
				results.size(), results, System.currentTimeMillis() - start);

	}

}
